
// TAG_DATA

#define NG_CENTER  1
#define NG_LEFT    2
#define NG_RIGHT   4
#define NG_TOP     8
#define NG_BOTTOM  16

// Sliderpositionen

#define NG_HORI         1
#define NG_VERT         2

#define NG_SLIDER_NONE  0
#define NG_SLIDER_AUTO  1
#define NG_SLIDER_IMAGE 2

// Sklierung von Liniengadgets

#define NG_2D_AUTO    -1
#define NG_2D_NONE    0

//Transparenz

#define NG_TRANS_CLICKABLE  3
#define NG_TRANS_MANUEL     2
#define NG_TRANS_MANUAL     2
#define NG_TRANS_AUTO       1
#define NG_TRANS_NONE       0

//Serialize


#define NG_SERIALIZE_END      0
#define NG_SERIALZIE_POS      1
#define NG_SERIALIZE_MYINFO   2
#define NG_SERIALIZE_UPGFX    3
#define NG_SERIALIZE_MOGFX    4
#define NG_SERIALIZE_DOGFX    5
#define NG_SERIALZIE_TYPE     6
#define NG_SERIALZIE_VAR      7


// TAG_ITEMS

#define NG_DUMMY  0x80000000

#define NG_H_ALIGN           NG_DUMMY+1
#define NG_V_ALIGN           NG_DUMMY+2
#define NG_TEXT_POS          NG_DUMMY+3
#define NG_ROUNDBUTTON_DX    NG_DUMMY+4
#define NG_BORDER_DIST       NG_DUMMY+5
#define NG_VARIABLE          NG_DUMMY+6
#define NG_VALUE             NG_DUMMY+7
#define NG_INVERSE           NG_DUMMY+8

#define NG_NB_LISTEN         NG_DUMMY+9
#define NG_NB_PLUS           NG_DUMMY+10
#define NG_NB_MINUS          NG_DUMMY+11
#define NG_NB_MIN            NG_DUMMY+12
#define NG_NB_MAX            NG_DUMMY+13
#define NG_NB_STEP           NG_DUMMY+14

#define NG_PEN_F_UP          NG_DUMMY+15
#define NG_PEN_BG_UP         NG_DUMMY+16
#define NG_PEN_F_DOWN        NG_DUMMY+17
#define NG_PEN_BG_DOWN       NG_DUMMY+18

#define NG_BORDER            NG_DUMMY+19

#define NG_BB_TEXTENABLE     NG_DUMMY+20

#define NG_NOTICE            NG_DUMMY+21

#define NG_BOX_RED           NG_DUMMY+22
#define NG_BOX_GREEN         NG_DUMMY+23
#define NG_BOX_BLUE          NG_DUMMY+24
#define NG_BOX_RED_ENABLE    NG_DUMMY+25
#define NG_BOX_GREEN_ENABLE  NG_DUMMY+26
#define NG_BOX_BLUE_ENABLE   NG_DUMMY+27

#define NG_INT_CHARPOS       NG_DUMMY+28

#define NG_SLIDER_DIR        NG_DUMMY+29
#define NG_SLIDER_LISTEN     NG_DUMMY+09
#define NG_SLIDER_MINUS      NG_DUMMY+11
#define NG_SLIDER_MIN        NG_DUMMY+12
#define NG_SLIDER_MAX        NG_DUMMY+13
#define NG_SLIDER_PLUS       NG_DUMMY+10
#define NG_SLIDER_STEP       NG_DUMMY+14
#define NG_SLIDER_SIZE       NG_DUMMY+30
#define NG_SLIDER_KNOB_U     NG_DUMMY+31
#define NG_SLIDER_KNOB_D     NG_DUMMY+32
#define NG_SLIDER_KNOB_MODE  NG_DUMMY+33

#define NG_ARRAYSIZE         NG_DUMMY+34
#define NG_INDEX_X           NG_DUMMY+35
#define NG_INDEX_Y           NG_DUMMY+36

#define NG_EDIT_GET_MAX_Y    NG_DUMMY+37
#define NG_EDIT_GET_MAX_X    NG_DUMMY+38

#define NG_NOTICE_VALUE      NG_DUMMY+39

#define NG_EDIT_CHAR_Y       NG_DUMMY+40
#define NG_EDIT_CHAR_X       NG_DUMMY+41
#define NG_HOOK              NG_DUMMY+42
#define NG_EDIT_TAB          NG_DUMMY+43

#define NG_QUALIFIER         NG_DUMMY+44
#define NG_CHAR              NG_DUMMY+45
#define NG_CLASS             NG_DUMMY+46

#define NG_SLIDER_KNOB_ALPHA NG_DUMMY+47

#define NG_2D_X_AXIS         NG_DUMMY+48
#define NG_2D_Y_AXIS         NG_DUMMY+49
#define NG_2D_X_HELPLINES    NG_DUMMY+50
#define NG_2D_Y_HELPLINES    NG_DUMMY+51

#define NG_BACKGROUND_IMAGE  NG_DUMMY+52

#define NG_TABELLEN_INPUTGADGET NG_DUMMY+53

#define NG_TABELLEN_COL         NG_DUMMY+54
#define NG_TABELLEN_ROW         NG_DUMMY+55

#define NG_TABELLEN_SET_COL     NG_DUMMY+56
#define NG_TABELLEN_SET_ROW     NG_DUMMY+57
#define NG_TABELLEN_UPDATE      NG_DUMMY+58
#define NG_TABELLEN_GET_ELEMENTS NG_DUMMY+59
#define NG_TABELLEN_GET_VALUES  NG_DUMMY+60

#define NG_GADGET_CLEAR         NG_DUMMY+61

#define NG_CYCLE_ICON           NG_DUMMY+62
#define NG_CYCLE_ICON_DEEP1     NG_DUMMY+63
#define NG_CYCLE_ICON_DEEP2     NG_DUMMY+64
#define NG_CYCLE_ELEMENT        NG_DUMMY+65

#define NG_NOBLOCKING           NG_DUMMY+66

#define NG_CHECKBOX_ICON_NORMAL NG_DUMMY+67
#define NG_CHECKBOX_ICON_SELECT NG_DUMMY+68

#define NG_TEXT_MULTILINE       NG_DUMMY+69

#define NG_DONT_ADD_TO_GUI      NG_DUMMY+70
#define NG_TEXT_SCROLLER        NG_DUMMY+71

#define NG_GLOBAL_BGPICTURE     NG_DUMMY+72
#define NG_GLOBAL_BORDER        NG_DUMMY+73

#define NG_STRING_PASSWORD      NG_DUMMY+74
#define NG_BOX_DEVIDER          NG_DUMMY+75
#define NG_BOX_ADDITIONALTEXT   NG_DUMMY+76

#define NG_GLOBAL_TEXTURE       NG_DUMMY+77

#define NG_BORDER_OUTSIDE_DIST  NG_DUMMY+78

#define NG_GADGETUP_HOOK        NG_DUMMY+79
#define NG_GADGETOVER_HOOK      NG_DUMMY+80
#define NG_GADGETDOWN_HOOK      NG_DUMMY+81

#define NG_THEMEABLE            NG_DUMMY+82
#define NG_THEME_ID             NG_DUMMY+83

#define NG_SCREEN               NG_DUMMY+84
#define NG_SCREEN_ID            NG_DUMMY+85
#define NG_SCREEN_WIDTH         NG_DUMMY+86
#define NG_SCREEN_HEIGHT        NG_DUMMY+87
#define NG_AUTOFLAGS_DISABLE    NG_DUMMY+88

#define NG_TRANS_MODE           NG_DUMMY+89
#define NG_TRANS_DEEP           NG_DUMMY+90
#define NG_TRANS_LEVEL_R        NG_DUMMY+91
#define NG_TRANS_LEVEL_G        NG_DUMMY+92
#define NG_TRANS_LEVEL_B        NG_DUMMY+93

#define NG_TEXT_SCROLLER_POS    NG_DUMMY+94
#define NG_SIZEABLE             NG_DUMMY+95
#define NG_GLOBAL_THEMEID       NG_DUMMY+96
#define NG_GLOBAL_FORCETHEME    NG_DUMMY+97
#define NG_GLOBAL_FORCEGFX      NG_DUMMY+98
#define NG_KEYEVENTS            NG_DUMMY+99

#define LABEL_D0 0
#define LABEL_D1 1
#define LABEL_D2 2
#define LABEL_D3 3
#define LABEL_D4 4
#define LABEL_D5 5
#define LABEL_D6 6
#define LABEL_D7 7
#define LABEL_A0 8
#define LABEL_A1 9
#define LABEL_A2 10
#define LABEL_A3 11
#define LABEL_A4 12

#define INT           0
#define POINTER       1
#define POINTER_CACHE 2
#define FILE_CACHE    3

#define LONG 4
#define ARG 0xABCDEFEF

typedef struct{long id;long data;} tag_item;
