/* 
 
    (c) 2003-2006 Cyborg 

    {* String: Version="$VER: linuxclient (C) CYBORG 2006"*}

*/

#include "newgui.proto"

#include <stdlib.h>
#include <stdio.h>
#include <syslog.h>
#include <memory.h>
#include "amiga.h"
#include "defines.h"
#include "newgui_lib.h"


extern char *hostname;
extern int port;


int main(int argc,char **argv) {

    FILE *fh;
    char *p;
    long *ret,*tags,*tags2;
    long l=0,newgui=0,deep=0,fg=0,bg=0,alpha=0,textbg=0,gadget=0,msgclass=-1,msgchar=0,result,error;
    int len=0,i=0;
    char *tp;
    char *env = getenv("NGDISPLAY");
    char *buffer = malloc(1024);    

    if (env && strlen(env)>0) {
        char *pos = strchr(env,':');
        if (pos!=NULL) {
            port = atoi(pos+1);
            hostname = malloc(pos-env+1);
            memcpy(hostname,env,pos-env);
        } else hostname = env;
    }

    if (argc>1) hostname=argv[1];
    if (argc>2) port=atoi(argv[2]);

    printf("connecting to %s %d\n",hostname,port);

    ret = open_Window(100,11,640,501,"Linux Demo Window #1",
                      WFLG_DRAGBAR|WFLG_REPORTMOUSE|WFLG_DEPTHGADGET|WFLG_CLOSEGADGET|WFLG_RMBTRAP|WFLG_SMART_REFRESH,
                      IDCMP_MOUSEBUTTONS|IDCMP_ACTIVEWINDOW|IDCMP_MOUSEMOVE);

    if (ret!=NULL) newgui=ret[0];

    if (newgui!=0) 
     {
//        printf("Window opend :-) trust me -> %08x\nReworking\n",big(newgui));

        ret = CreateDeep(newgui,"test.deep");
        
        if (ret!=NULL) deep=ret[0];

        if (deep!=0) {
            ret=(long *)malloc(16);
            ret[0]=big(NG_BACKGROUND_IMAGE);
            ret[1]=deep;
            ret[2]=TAG_DONE;
            ret[3]=0;

            UpdateGui(newgui,ret);
        }

        workGui(newgui,NULL);


        tags=(long *)malloc(24);

        tags[0]=big(NG_TEXT_POS);tags[1]=big(NG_CENTER);
        tags[2]=big(NG_BORDER);  tags[3]=big(1);
        tags[4]=TAG_DONE;        tags[5]=0;

        tags2=(long *)malloc(48);

        tags2[0]=big(NG_TEXT_POS);      tags2[1]=big(NG_TOP);
        tags2[2]=big(NG_BORDER);        tags2[3]=big(1);
        tags2[4]=big(NG_TEXT_MULTILINE);tags2[5]=big(1);
        tags2[6]=big(NG_PEN_F_UP);      tags2[7]=big(2);
        tags2[8]=big(NG_PEN_BG_UP);      tags2[9]=big(-1);
        tags2[10]=TAG_DONE;              tags2[11]=0;

        ret = CreateGadgetGeneric(newgui,10,485,80,11,"ok",0,0,0,"generic/button.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        ret = CreateGadgetGeneric(newgui,100,485,80,11,"TOP",0,0,0,"generic/button.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        ret = CreateGadgetGeneric(newgui,190,485,80,11,"Pstree",0,0,0,"generic/button.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        ret = CreateGadgetGeneric(newgui,280,485,80,11,"Load",0,0,0,"generic/button.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        ret=MakeEmptyDeep(newgui,"alpha",600,440);
        if (ret!=NULL) alpha=ret[0];

        ret=MakeEmptyDeep(newgui,"fg",600,440);
        if (ret!=NULL) fg=ret[0];

        FillDeep(alpha,64,64,64);
        FillDeep(fg,32,32,32);

        
        ret=GuiToDeep(newgui,20,20,600,440);
        if (ret!=NULL) bg=ret[0];

        ret=MixDeep(newgui,bg,fg,alpha);
        if (ret!=NULL) textbg=ret[0];


        ret = CreateGadgetGeneric(newgui,20,20,600,440,"",textbg,textbg,textbg,"generic/text.library",tags2);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }


        ret = CreateGadgetGeneric(newgui,370,485,80,11,"Uptime",0,0,0,"generic/button.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        ret = CreateGadgetGeneric(newgui,460,485,80,11,"",0,0,0,"generic/string.library",tags);
        if (ret!=NULL) {
            result=ret[0];
            error=ret[1];
            if (result==0) {
                printf("Gadget konnte nicht erstellt werden %08x\n",big(error));
            } // else printf("Gadget %08x -> %08x\n",big(result),big(error));
        }

        while(msgclass!=IDCMP_CLOSEWINDOW) {

            ret = WaitGuiEvent(newgui,NULL);
            if (ret!=NULL) {
                gadget=big(ret[0]);
                msgclass=big(ret[1]);

//                printf("gadget=0x%08x msgclass=0x%08x\n",gadget,msgclass);

                if (msgclass==IDCMP_MOUSEBUTTONS && gadget!=0) 
                 {
                    ret = getGadgetStatus(newgui,gadget);
                    if (ret!=NULL) {
                        result = big(ret[0]);
                        if (result==0) {
//                                printf("Gadget %d is up\n",gadget);

                                if( gadget==1 ) msgclass=IDCMP_CLOSEWINDOW;
                                if( gadget==2 ) {
                                        system("top -c -b -n 1 >/tmp/.live");
                                        if (fh=fopen("/tmp/.live","r")) {
                                           fseek(fh,0,SEEK_END);
                                           len=ftell(fh);
                                           fseek(fh,0,SEEK_SET);
                                           tp=(char *)malloc(len+1);
                                           fread(tp,len,1,fh);
                                           fclose(fh);
                                           UpdateGadgetValue(newgui,5,(long *)tp,len+1);
                                        } else printf("file not opened error\n");
                                }
                                if( gadget==3 ) {
                                        system("pstree -uA >/tmp/.live");
                                        if (fh=fopen("/tmp/.live","r")) {
                                           fseek(fh,0,SEEK_END);
                                           len=ftell(fh);
                                           fseek(fh,0,SEEK_SET);
                                           tp=(char *)malloc(len+1);
                                           fread(tp,len,1,fh);
                                           fclose(fh);
                                           for(i=0;i<len;i++) if (tp[i]=='*') tp[i]='x';
                                                
                                           
 
                                           UpdateGadgetValue(newgui,5,(long *)tp,len+1);
                                        } else printf("file not opened error\n");
                                }
                                if( gadget==4 ) {
                                        system("cat /proc/loadavg >/tmp/.live");
                                        if (fh=fopen("/tmp/.live","r")) {
                                           fseek(fh,0,SEEK_END);
                                           len=ftell(fh);
                                           fseek(fh,0,SEEK_SET);
                                           tp=(char *)malloc(len+1);
                                           fread(tp,len,1,fh);
                                           fclose(fh);
                                           UpdateGadgetValue(newgui,5,(long *)tp,len+1);
                                        } else printf("file not opened error\n");
                                }

                                if( gadget==6 ) {
                                        system("uptime >/tmp/.live");
                                        if (fh=fopen("/tmp/.live","r")) {
                                           fseek(fh,0,SEEK_END);
                                           len=ftell(fh);
                                           fseek(fh,0,SEEK_SET);
                                           tp=(char *)malloc(len+1);
                                           fread(tp,len,1,fh);
                                           fclose(fh);
                                           UpdateGadgetValue(newgui,5,(long *)tp,len+1);
                                        } else printf("file not opened error\n");
                                }
                                
                        }
/*
                        if (result==1) printf("Gadget %d is mouseover\n",gadget);
                        if (result==2) printf("Gadget %d is down\n",gadget);
                        if (result==4) printf("Gadget %d is listening\n",gadget);
*/
                    }
                 }
                if (msgclass==IDCMP_VANILLAKEY) 
                 {
                    ret = getPressedKey(newgui);
                    if (ret!=NULL) msgchar=big(ret[0]);

                    if (msgchar==ESCAPEKEY) break;


                    if( gadget==7 ) {
                    
                            ret = GetGadgetValue(newgui,big(gadget));
                            if (ret!=NULL) {
                                result=ret[0];
                                p=_getAmigaString(result);
                                sprintf(buffer,"%s >/tmp/.live",p);
                                system(buffer);
	                            if (fh=fopen("/tmp/.live","r")) {
        	                       fseek(fh,0,SEEK_END);
                	           len=ftell(fh);
                        	   fseek(fh,0,SEEK_SET);
	                               tp=(char *)malloc(len+1);
        	                       fread(tp,len,1,fh);
                	           fclose(fh);
                        	   UpdateGadgetValue(newgui,5,(long *)tp,len+1);
	                            } else printf("file not opened error\n");
                            }
                    }


                 }




                if (msgclass==IDCMP_CLOSEWINDOW) break;
             

            } else {
                msgclass=IDCMP_CLOSEWINDOW;
                // Fallback fr den Fall , da der WaitGuiEvent nicht klappt!
            }
        }
        
//        printf("Window closing\n");

        if (deep!=0)   FreeDeep(deep);
        if (alpha!=0)  FreeDeep(alpha);
        if (fg!=0)     FreeDeep(fg);
        if (bg!=0)     FreeDeep(bg);
        if (textbg!=0) FreeDeep(textbg);
    
        close_Window(newgui);

     }

    return 0;
}

