#define TAG_DONE 0;

#define TAGPOINTER1 TAG_USER+100

// these tags simply override NewWindow parameters
#define WA_Left TAGPOINTER1+0
#define WA_Top TAGPOINTER1+1
#define WA_Width TAGPOINTER1+2
#define WA_Height TAGPOINTER1+3
#define WA_DetailPen TAGPOINTER1+4
#define WA_BlockPen TAGPOINTER1+5
#define WA_IDCMP TAGPOINTER1+6
#define WA_Flags TAGPOINTER1+7	// not implemented at present
#define WA_Gadgets TAGPOINTER1+8
#define WA_Checkmark TAGPOINTER1+9
#define WA_Title TAGPOINTER1+10
#define WA_ScreenTitle TAGPOINTER1+11
#define WA_CustomScreen TAGPOINTER1+12
#define WA_SuperBitMap TAGPOINTER1+13
#define WA_MinWidth TAGPOINTER1+14
#define WA_MinHeight TAGPOINTER1+15
#define WA_MaxWidth TAGPOINTER1+16
#define WA_MaxHeight TAGPOINTER1+17
#define WA_InnerWidth TAGPOINTER1+18
#define WA_InnerHeight TAGPOINTER1+19
#define WA_PubScreenName TAGPOINTER1+20
#define WA_PubScreen TAGPOINTER1+21
#define WA_PubScreenFallBack TAGPOINTER1+22
#define WA_WindowName TAGPOINTER1+23	// not implemented
#define WA_Colors TAGPOINTER1+24
#define WA_Zoom TAGPOINTER1+25
#define WA_MouseQueue TAGPOINTER1+26
#define WA_BackFill TAGPOINTER1+27
#define WA_RptQueue TAGPOINTER1+28
#define WA_SizeGadget TAGPOINTER1+29
#define WA_DragBar TAGPOINTER1+30
#define WA_DepthGadget TAGPOINTER1+31
#define WA_CloseGadget TAGPOINTER1+32
#define WA_Backdrop TAGPOINTER1+33
#define WA_ReportMouse TAGPOINTER1+34
#define WA_NoCareRefresh TAGPOINTER1+35
#define WA_Borderless TAGPOINTER1+36
#define WA_Activate TAGPOINTER1+37
#define WA_RMBTrap TAGPOINTER1+38
#define WA_WBenchWindow TAGPOINTER1+39	// PRIVATE!!
#define WA_SimpleRefresh TAGPOINTER1+40	
#define WA_SmartRefresh TAGPOINTER1+41	
#define WA_SizeBRight TAGPOINTER1+42
#define WA_SizeBBottom TAGPOINTER1+43
#define WA_AutoAdjust TAGPOINTER1+44
#define WA_GimmeZeroZero TAGPOINTER1+45 
#define WA_MenuHelp TAGPOINTER1+46	
#define WA_NewLookMenus TAGPOINTER1+47
#define WA_AmigaKey TAGPOINTER1+48 
#define WA_NotifyDepth TAGPOINTER1+49
#define WA_Obsolete TAGPOINTER1+50
#define WA_Pointer TAGPOINTER1+51
#define WA_BusyPointer TAGPOINTER1+52
#define WA_PointerDelay TAGPOINTER1+53
#define WA_TabletMessages TAGPOINTER1+54
#define WA_HelpGroup TAGPOINTER1+55
#define WA_HelpGroupWindow TAGPOINTER1+56

// Gadget Class attributes

#define GA_Dummy		 	TAG_USER+0x30000
#define GA_Left			 	GA_Dummy+0x0001
#define GA_RelRight		 	GA_Dummy+0x0002
#define GA_Top			 	GA_Dummy+0x0003
#define GA_RelBottom	 	GA_Dummy+0x0004
#define GA_Width		 	GA_Dummy+0x0005
#define GA_RelWidth		 	GA_Dummy+0x0006
#define GA_Height		 	GA_Dummy+0x0007
#define GA_RelHeight	 	GA_Dummy+0x0008
#define GA_Text			 	GA_Dummy+0x0009  // ti_Data is UBYTE *
#define GA_Image		 	GA_Dummy+0x000A
#define GA_Border		 	GA_Dummy+0x000B
#define GA_SelectRender	 	GA_Dummy+0x000C
#define GA_Highlight	 	GA_Dummy+0x000D
#define GA_Disabled		 	GA_Dummy+0x000E
#define GA_GZZGadget	 	GA_Dummy+0x000F
#define GA_ID			 	GA_Dummy+0x0010
#define GA_UserData		 	GA_Dummy+0x0011
#define GA_SpecialInfo	 	GA_Dummy+0x0012
#define GA_Selected		 	GA_Dummy+0x0013
#define GA_EndGadget	 	GA_Dummy+0x0014
#define GA_Immediate	 	GA_Dummy+0x0015
#define GA_RelVerify	 	GA_Dummy+0x0016
#define GA_FollowMouse	 	GA_Dummy+0x0017
#define GA_RightBorder	 	GA_Dummy+0x0018
#define GA_LeftBorder	 	GA_Dummy+0x0019
#define GA_TopBorder	 	GA_Dummy+0x001A
#define GA_BottomBorder	 	GA_Dummy+0x001B
#define GA_ToggleSelect	 	GA_Dummy+0x001C
#define GA_SysGadget	 	GA_Dummy+0x001D
#define GA_SysGType		 	GA_Dummy+0x001E
#define GA_Previous		 	GA_Dummy+0x001F
#define GA_Next			 	GA_Dummy+0x0020
#define GA_DrawInfo		 	GA_Dummy+0x0021
#define GA_IntuiText	 	GA_Dummy+0x0022
#define GA_LabelImage	 	GA_Dummy+0x0023
#define GA_TabCycle		 	GA_Dummy+0x0024
#define GA_GadgetHelp	 	GA_Dummy+0x0025
#define GA_Bounds		 	GA_Dummy+0x0026
#define GA_RelSpecial	 	GA_Dummy+0x0027
#define PGA_Dummy		 	TAG_USER+0x31000
#define PGA_Freedom		 	PGA_Dummy+0x0001
#define PGA_Borderless	 	PGA_Dummy+0x0002
#define PGA_HorizPot	 	PGA_Dummy+0x0003
#define PGA_HorizBody	 	PGA_Dummy+0x0004
#define PGA_VertPot		 	PGA_Dummy+0x0005
#define PGA_VertBody	 	PGA_Dummy+0x0006
#define PGA_Total		 	PGA_Dummy+0x0007
#define PGA_Visible		 	PGA_Dummy+0x0008
#define PGA_Top			 	PGA_Dummy+0x0009

// New for V37:
#define PGA_NewLook		 	PGA_Dummy+0x000A
#define STRINGA_Dummy  		 	TAG_USER+0x32000
#define STRINGA_MaxChars	 	STRINGA_Dummy+0x0001
#define STRINGA_Buffer		 	STRINGA_Dummy+0x0002
#define STRINGA_UndoBuffer	 	STRINGA_Dummy+0x0003
#define STRINGA_WorkBuffer	 	STRINGA_Dummy+0x0004
#define STRINGA_BufferPos	 	STRINGA_Dummy+0x0005
#define STRINGA_DispPos		 	STRINGA_Dummy+0x0006
#define STRINGA_AltKeyMap	 	STRINGA_Dummy+0x0007
#define STRINGA_Font		 	STRINGA_Dummy+0x0008
#define STRINGA_Pens		 	STRINGA_Dummy+0x0009
#define STRINGA_ActivePens	 	STRINGA_Dummy+0x000A
#define STRINGA_EditHook	 	STRINGA_Dummy+0x000B
#define STRINGA_EditModes	 	STRINGA_Dummy+0x000C
#define STRINGA_ReplaceMode	 	STRINGA_Dummy+0x000D
#define STRINGA_FixedFieldMode	 	STRINGA_Dummy+0x000E
#define STRINGA_NoFilterMode	 	STRINGA_Dummy+0x000F
#define STRINGA_Justification	 	STRINGA_Dummy+0x0010
#define STRINGA_LongVal		 	STRINGA_Dummy+0x0011
#define STRINGA_TextVal		 	STRINGA_Dummy+0x0012
#define STRINGA_ExitHelp	 	STRINGA_Dummy+0x0013
#define SG_DEFAULTMAXCHARS	 	128
#define LAYOUTA_Dummy 		 	TAG_USER+0x38000
#define LAYOUTA_LayoutObj	 	LAYOUTA_Dummy+0x0001
#define LAYOUTA_Spacing		 	LAYOUTA_Dummy+0x0002
#define LAYOUTA_Orientation	 	LAYOUTA_Dummy+0x0003
#define LORIENT_NONE		 	0
#define LORIENT_HORIZ		 	1
#define LORIENT_VERT		 	2
#define GM_HITTEST  		0	// return GMR_GADGETHIT if you are clicked
#define GM_RENDER  		1	// draw yourself, in the appropriate state
#define GM_GOACTIVE  		2	// you are now going to be fed input
#define GM_HANDLEINPUT  	3	// handle that input
#define GM_GOINACTIVE  	4	        // whether or not by choice, you are done
#define GM_HELPTEST  		5	// Will you send gadget help if the mouse is
#define GM_LAYOUT  		6	// re-evaluate your size based on the GadgetInfo
#define GMR_GADGETHIT	  0x00000004	// GM_HITTEST hit
#define GMR_NOHELPHIT	  0x00000000	// GM_HELPTEST didn't hit
#define GMR_HELPHIT	  0xFFFFFFFF	// GM_HELPTEST hit, return code = ~0
#define GMR_HELPCODE	  0x00010000	// GM_HELPTEST hit, return low word as code
#define GREDRAW_UPDATE	  2	// update for change in attributesvalues
#define GREDRAW_REDRAW	  1	// redraw gadget
#define GREDRAW_TOGGLE	  0	// toggle highlight, if applicable
#define GMR_MEACTIVE	  0x0000	// (bugfix: was 0x0001 during betan)
#define GMR_NOREUSE	  0x0002
#define GMR_REUSE	  0x0004
#define GMR_VERIFY	  0x0008	// you MUST set gpi_Termination
#define GMR_NEXTACTIVE	  0x0010
#define GMR_PREVACTIVE	  0x0020
#define GMRB_NOREUSE	  1
#define GMRB_REUSE	  2
#define GMRB_VERIFY	  3
#define GMRB_NEXTACTIVE	  4
#define GMRB_PREVACTIVE	  5

#define GMRF_NOREUSE	          0x0002
#define GMRF_REUSE	              0x0004
#define GMRF_VERIFY	              0x0008
#define GMRF_NEXTACTIVE	          0x0010
#define GMRF_PREVACTIVE	          0x0020
#define GFLG_GADGHIGHBITS	  0x0003
#define GFLG_GADGHCOMP		  0x0000	// Complement the select box
#define GFLG_GADGHBOX		  0x0001	// Draw a box around the image
#define GFLG_GADGHIMAGE		  0x0002	// Blast in this alternate image
#define GFLG_GADGHNONE		  0x0003	// don't highlight
#define GFLG_GADGIMAGE		  0x0004
#define GFLG_RELBOTTOM		  0x0008	// set if rel to bottom, clear if to top
#define GFLG_RELRIGHT		  0x0010	// set if rel to right, clear if to left
#define GFLG_RELWIDTH		  0x0020
#define GFLG_RELHEIGHT		  0x0040
#define GFLG_RELSPECIAL		  0x4000 // custom gadget has special relativity.
#define GFLG_SELECTED		  0x0080
#define GFLG_DISABLED		  0x0100
#define GFLG_LABELMASK		  0x3000
#define GFLG_LABELITEXT		  0x0000	// GadgetText points to IntuiText
#define GFLG_LABELSTRING	  0x1000	// GadgetText points to (UBYTE *)
#define GFLG_LABELIMAGE		  0x2000	// GadgetText points to Image (object)
#define GFLG_TABCYCLE		  0x0200	// (string or custom) gadget
#define GFLG_STRINGEXTEND	  0x0400 // this String Gadget has StringExtend
#define GFLG_IMAGEDISABLE 	  0x0800 // Gadget's image knows how to do disabled
#define GFLG_EXTENDED		  0x8000 // Gadget is extended
#define GACT_RELVERIFY		  0x0001
#define GACT_IMMEDIATE		  0x0002
#define GACT_ENDGADGET		  0x0004
#define GACT_FOLLOWMOUSE	  0x0008
#define GACT_RIGHTBORDER	  0x0010
#define GACT_LEFTBORDER		  0x0020
#define GACT_TOPBORDER		  0x0040
#define GACT_BOTTOMBORDER	  0x0080
#define GACT_BORDERSNIFF	  0x8000	// neither set nor rely on this bit
#define GACT_TOGGLESELECT	  0x0100	// this bit for toggle-select mode
#define GACT_BOOLEXTEND		  0x2000	// This Boolean Gadget has a BoolInfo
#define GACT_STRINGLEFT		  0x0000	// NOTE WELL: that this has value zero
#define GACT_STRINGCENTER	  0x0200	// center the String
#define GACT_STRINGRIGHT	  0x0400	// right-justify the String
#define GACT_LONGINT		  0x0800	// This String Gadget is a Long Integer
#define GACT_ALTKEYMAP		  0x1000	// has an alternate keymapping
#define GACT_STRINGEXTEND	  0x2000	// this String Gadget has an extension
#define GACT_ACTIVEGADGET	  0x4000	// this gadget is "active".  This flag
#define GTYP_GADGETTYPE		  0xFC00	// all Gadget Global Type flags
#define GTYP_SCRGADGET		  0x4000	// 1 = ScreenGadget, 0 = WindowGadget
#define GTYP_GZZGADGET		  0x2000	// 1 = Gadget for WFLG_GIMMEZEROZERO
#define GTYP_REQGADGET		  0x1000	// 1 = this is a Requester Gadget
#define GTYP_SYSGADGET		  0x8000
#define GTYP_SYSTYPEMASK	  0x00F0
#define GTYP_SIZING		          0x0010	// Window sizing gadget
#define GTYP_WDRAGGING		  0x0020	// Window drag bar
#define GTYP_SDRAGGING		  0x0030	// Screen drag bar
#define GTYP_WDEPTH		          0x0040	// Window depth gadget
#define GTYP_SDEPTH		          0x0050	// Screen depth gadget
#define GTYP_WZOOM		          0x0060	// Window zoom gadget
#define GTYP_SUNUSED		  0x0070	// Unused screen gadget
#define GTYP_CLOSE		          0x0080	// Window close gadget
#define GTYP_WUPFRONT		  GTYP_WDEPTH	// Window to-front gadget
#define GTYP_SUPFRONT		  GTYP_SDEPTH	// Screen to-front gadget
#define GTYP_WDOWNBACK		  GTYP_WZOOM	// Window to-back gadget
#define GTYP_SDOWNBACK		  GTYP_SUNUSED	// Screen to-back gadget
#define GTYP_GTYPEMASK		  0x0007
#define GTYP_BOOLGADGET		  0x0001
#define GTYP_GADGET0002		  0x0002
#define GTYP_PROPGADGET		  0x0003
#define GTYP_STRGADGET		  0x0004
#define GTYP_CUSTOMGADGET	  0x0005
#define GMORE_BOUNDS		  0x00000001 // ExtGadget has valid Bounds
#define GMORE_GADGETHELP	  0x00000002 // This gadget responds to gadget help
#define GMORE_SCROLLRASTER	  0x00000004 // This (custom) gadget uses ScrollRaster
#define BOOLMASK	 	0x0001	// extension is for masked gadget
#define IDCMP_SIZEVERIFY	  0x00000001
#define IDCMP_NEWSIZE		  0x00000002
#define IDCMP_REFRESHWINDOW	  0x00000004
#define IDCMP_MOUSEBUTTONS	  0x00000008
#define IDCMP_MOUSEMOVE		  0x00000010
#define IDCMP_GADGETDOWN	  0x00000020
#define IDCMP_GADGETUP		  0x00000040
#define IDCMP_REQSET		  0x00000080
#define IDCMP_MENUPICK		  0x00000100
#define IDCMP_CLOSEWINDOW	  0x00000200
#define IDCMP_RAWKEY		  0x00000400
#define IDCMP_REQVERIFY		  0x00000800
#define IDCMP_REQCLEAR		  0x00001000
#define IDCMP_MENUVERIFY	  0x00002000
#define IDCMP_NEWPREFS		  0x00004000
#define IDCMP_DISKINSERTED	  0x00008000
#define IDCMP_DISKREMOVED	  0x00010000
#define IDCMP_WBENCHMESSAGE	  0x00020000	// System use only
#define IDCMP_ACTIVEWINDOW	  0x00040000
#define IDCMP_INACTIVEWINDOW	  0x00080000
#define IDCMP_DELTAMOVE		  0x00100000
#define IDCMP_VANILLAKEY	  0x00200000
#define IDCMP_INTUITICKS	  0x00400000
#define IDCMP_IDCMPUPDATE	  0x00800000	// new for V36
#define IDCMP_MENUHELP		  0x01000000	// new for V36
#define IDCMP_CHANGEWINDOW	  0x02000000	// new for V36
#define IDCMP_GADGETHELP	  0x04000000	// new for V39
#define IDCMP_WBScreenupdate	  0x08000000	// Selbstgemachtes IDCMP
#define IDCMP_LONELYMESSAGE	  0x80000000
// --- IDCMP Codes --------------------------------------------------------
// This group of codes is for the IDCMP_CHANGEWINDOW message
#define CWCODE_MOVESIZE           0x0000	// Window was moved and/or sized
#define CWCODE_DEPTH	          0x0001	// Window was depth-arranged (new for V39)
#define MENUHOT		              0x0001	// IntuiWants verification or MENUCANCEL
#define MENUCANCEL	              0x0002	// HOT Reply of this cancels Menu operation
#define MENUWAITING	              0x0003	// Intuition simply wants a ReplyMsg() ASAP
#define OKOK		              MENUHOT		// guy didn't care
#define OKABORT		              0x0004		// window rendered question moot
#define OKCANCEL 	              MENUCANCEL 	// window sent cancel reply
#define WBENCHOPEN	              0x0001
#define WBENCHCLOSE	              0x0002
#define WFLG_SIZEGADGET           0x0001 
#define WFLG_DRAGBAR              0x0002
#define WFLG_DEPTHGADGET          0x0004
#define WFLG_CLOSEGADGET          0x0008
#define WFLG_SIZEBRIGHT           0x0010
#define WFLG_SIZEBBOTTOM          0x0020
#define WFLG_REFRESHBITS          0x00C0
#define WFLG_SMART_REFRESH        0x0000
#define WFLG_SIMPLE_REFRESH       0x0040
#define WFLG_SUPER_BITMAP         0x0080
#define WFLG_OTHER_REFRESH        0x00C0
#define WFLG_BACKDROP             0x0100
#define WFLG_REPORTMOUSE          0x0200
#define WFLG_GIMMEZEROZERO        0x0400
#define WFLG_BORDERLESS           0x0800
#define WFLG_ACTIVATE             0x1000
#define WFLG_RMBTRAP              0x00010000
#define WFLG_NOCAREREFRESH        0x00020000
#define WFLG_NW_EXTENDED          0x00040000
#define WFLG_NEWLOOKMENUS         0x00200000
#define WFLG_WINDOWACTIVE         0x2000
#define WFLG_INREQUEST            0x4000
#define WFLG_MENUSTATE            0x8000
#define WFLG_WINDOWREFRESH        0x01000000
#define WFLG_WBENCHWINDOW         0x02000000
#define WFLG_WINDOWTICKED         0x04000000
#define WFLG_VISITOR              0x08000000
#define WFLG_ZOOMED               0x10000000
#define WFLG_HASZOOM              0x20000000
#define SUPER_UNUSED              0xFCFC0000
#define DEFAULTMOUSEQUEUE         5
#define AUTOKNOB                  0x0001	// this flag sez:  gimme that old auto-knob
#define FREEHORIZ                 0x0002	// if set, the knob can move horizontally
#define FREEVERT	              0x0004	// if set, the knob can move vertically
#define PROPBORDERLESS	          0x0008	// if set, no border will be rendered
#define KNOBHIT		              0x0100	// set when this Knob is hit
#define PROPNEWLOOK	              0x0010	// set this if you want to get the new
				                // V36 look
#define KNOBHMIN	              6	// minimum horizontal size of the knob
#define KNOBVMIN	              4	// minimum vertical size of the knob
#define MAXBODY		              0xFFFF	// maximum body value
#define MAXPOT			          0xFFFF	// maximum pot value

#define ESCAPEKEY 0x1b
